#include "Quicksort.h"

int getMedianPivot(int *values, int beginIndex, int endIndex)
{
    int pivot, middleIndex;
    int beginValue, endValue, middleValue;
    middleIndex  = (endIndex+beginIndex)/2;

    beginValue = values[beginIndex];
    endValue = values[endIndex-1];
    middleValue = values[middleIndex];

    if(beginValue > endValue)
        if(beginValue < middleValue)
            pivot = beginValue;
        else if(middleValue > endValue)
            pivot = middleValue;
        else
            pivot = endValue;
    else
        if(endValue < middleValue)
            pivot = endValue;
        else if(middleValue > beginValue)
            pivot = middleValue;
        else
            pivot = beginValue;

    return pivot;
}

void quicksort(int *values, int begin, int end)
{
	int i, j, pivot, aux;
	i = begin;
	j = end-1;
    pivot = getMedianPivot(values, begin, end);
	//pivot = values[(begin + end) / 2];

	while(i <= j)
	{
		while(i < end && values[i] < pivot)
		{
			i++;
		}
		while(j > begin && values[j] > pivot)
		{
			j--;
		}
		if(i <= j)
		{
			aux = values[i];
			values[i] = values[j];
			values[j] = aux;
			i++;
			j--;
		}
	}
	if(j > begin)
		quicksort(values, begin, j+1);
	if(i < end)
		quicksort(values, i, end);
}
